;*******************************************
;*                              *
;*******************************************
;* :              ..           *
;*  :  MPLAB IDE v7.31      *
;* :         PIC12F629            *
;*  :                      *
;*    GP0   -                *      
;*    GP1   -          *
;*    GP3   -        *
;*    T0SKI -        *
;*    OSC1,OSC2  -  4              *
;*                    kotov_ig@mail.ru     *
;*******************************************

          NOLIST
        #INCLUDE <P12F629.inc>
 __CONFIG _MCLRE_OFF & _WDT_OFF & _XT_OSC & _PWRTE_ON & _BODEN_ON & _CP_OFF & _CPD_OFF
            
         ERRORLEVEL 2
	
         DIO         EQU  0  ; 
         INS         EQU  1  ;  
         BTN         EQU  3  ;  
         
;      FLAG       

         LONG_CLICK  EQU  0  ;   
         SHOT_CLICK  EQU  1  ;  
         CHANGE      EQU  2  ;  

;     MODE
; 0         100mS
; 1         100mS,dF
; 2         1S
; 3         1S,dF
; 4          
; 5 	   
; 6	  
	    
    CONSTANT TIME_MAX = 0x70 ;   
    CONSTANT TIME_MIN = 0x05 ;  
        
 	  CBLOCK 0x20
          S_TMP      ;   STATUS          
	W_TMP      ;   W
	FLAG       ; 
	MODE       ; 
          TIME       ;   
          ZIKL       ;    0,1
          IMP1_TMP   ;  
          IMP2_TMP   ;  
          IMP3_TMP
          IMP4_TMP
	IMP1       ; 
	IMP2 
	IMP3
	IMP4
	TMP1       ; 
	TMP2
	TMP3
	TMP4
	TMP5 
	TMP6
	SEC1       ;  
	SEC2       ; SEC1, SEC2
	CNT1       ;      
	CNT2       ;   
	CNT3
          CNT4
	IND0       ; 
	IND1
	IND2 
	IND3
	IND4
	IND5 
	IND6
	IND7
	IND8
	IND9   
 	  ENDC

         LIST

  	  ORG 0x00
 	B INIT 
            ORG 0x04
          B INTER
          
;***********************************************
;*     *
;***********************************************

INDTBL    ADDWF PCL  ;  
 	RETLW 0x0A ; 0     - 0x00
	RETLW 0x01 ; 1     - 0x01
	RETLW 0x02 ; 2     - 0x02
	RETLW 0x03 ; 3     - 0x03
          RETLW 0x04 ; 4     - 0x04
	RETLW 0x05 ; 5     - 0x05
          RETLW 0x06 ; 6     - 0x06
	RETLW 0x07 ; 7     - 0x07
          RETLW 0x08 ; 8     - 0x08
	RETLW 0x09 ; 9     - 0x09
	RETLW 0x00 ; SPASE - 0x0A
          RETLW 0x0B ; F     - 0x0B
	RETLW 0x0C ; _|    - 0x0C 
	RETLW 0x0D ; |_    - 0x0D
	RETLW 0x0E ; P     - 0x0E
	RETLW 0x0F ; -     - 0x0F

;***********************************************
;*         *
;***********************************************
	
MODTBL    ADDWF PCL   
 	RETLW 0x01  ; 100mS,dF
	RETLW 0x00  ; 100mS
	RETLW 0x03  ; 1S,dF
	RETLW 0x02  ; 1S
	RETLW 0x05  ;  
	RETLW 0x06  ; 
	RETLW 0x04  ;  
	
;***********************************************
;*                      *
;***********************************************
	
INIT      BCF GPIO,DIO       
          MOVLW  B'00010001' ; TMR1  
	MOVWF  T1CON       ; F/2
	BSF STATUS,RP0     ;  1
	BCF TRISIO,DIO     ;DIO  
	BSF INTCON,T0IE    ; .TMR0 
	MOVLW  B'00110111' ; TMR0    
          MOVWF  OPTION_REG  ; F/256
	BSF PIE1,TMR1IE    ; .TMR1
          BSF INTCON,PEIE    ;  .
          BCF STATUS,RP0     ;  0	
          CALL D1S           ; 1 
          MOVLW 0x23         ;  
	MOVWF S_TMP        ;  CBLOCK
	MOVLW W_TMP        ; 0x20  0x44
	MOVWF FSR
	CLRF INDF
	INCF FSR
          DECFSZ S_TMP
	B $-3
	CLRF TMR0	
          CLRF TMR1H
          CLRF TMR1L	
          BSF INTCON,GIE     ;  .
          
;***********************************************
;*                                  *
;***********************************************	   

START     CALL D10mS            ;    10
	BTFSC GPIO,BTN        ;   BTN  
          B ST2                 ;  
          INCF TIME             ;  BTN   TIME   
	BTFSC FLAG,LONG_CLICK ;   ?  
	B ST2                 ;  
          BTFSC FLAG,SHOT_CLICK ;   ? 
	B ST1                 ;   
          MOVF TIME,W           ; TIME=TIME_MIN 
	SUBLW TIME_MIN        ;     
	SKPNZ                 ; 
	BSF FLAG,SHOT_CLICK   ; SHOT_CLICK
ST1	MOVF TIME,W           ; TIME=TIME_MAX 
	SUBLW TIME_MAX        ; 
	BNZ START             ; 
	SKPNZ                 ; LONG_CLICK
	BSF FLAG,LONG_CLICK
	B START
ST2       CLRF TIME
	BTFSS FLAG,LONG_CLICK ;   ?
	B ST6
	BCF FLAG,LONG_CLICK   ;   
	BCF FLAG,SHOT_CLICK   ;   , 
	MOVF MODE,W           ;   
	SUBLW 0x01            ;(0,1)->(2,3)->(4,5,6)
	BNC ST3               
	MOVLW 0x02            
	B ST4
ST3	MOVF MODE,W
	SUBLW 0x03
	MOVLW 0x00 
	SKPNC  
          MOVLW 0x04
ST4       BCF INTCON,GIE        ;        
	MOVWF MODE	  ; , 
	BSF FLAG,CHANGE       ;   CHANGE
	BSF PIR1,T1IF
	CALL INTER
ST5	BTFSS GPIO,BTN
          B ST5
          B START
ST6       BTFSS FLAG,SHOT_CLICK ;   ?
          B ST5
          BCF FLAG,SHOT_CLICK   ;   	
          MOVF MODE,W           ;   , 
          CALL MODTBL           ;   
          B ST4                 ;   MODTBL

;***********************************************
;*         *
;***********************************************	             

INTER     MOVWF W_TMP
	SWAPF STATUS,W
	MOVWF S_TMP
          BTFSC INTCON,T0IF
          B IMPINC 
          MOVF MODE,W
          ADDWF PCL
          B FR_mS
          B FR_mS_dF
          B FR_S
     	B FR_S_dF
          B CN_WAIT
          B CN_START
          B CN_STOP
          
;***********************************************
;*           *
;***********************************************
	
IMPINC    BCF INTCON,T0IF
	INCF IMP3
	SKPNZ
	INCF IMP4
	B ENDINT
	
;***********************************************
;*         100      *
;***********************************************	
   
FR_mS     BCF PIR1,TMR1IF
	BSF GPIO,INS       
          BSF STATUS,RP0     ;0
          BCF TRISIO,INS     ;  , 0,1
          BCF STATUS,RP0     ;1
          BTFSS FLAG,CHANGE  ;   ?    
          B FR1
          CALL INITPRES      ;  -   TMR0,TMR1
          B FR2
FR1       CALL CLRPRES       ;    TMR0
          MOVF IMP1,W        ;  ,  
          MOVWF IMP1_TMP     ; BINDEC  
          MOVF IMP2,W
          MOVWF TMR0
          MOVWF IMP2_TMP
          MOVF IMP3,W
          MOVWF IMP3_TMP
          MOVF IMP4,W
          MOVWF IMP4_TMP
FR2	CALL BINDEC        ;-  
          MOVLW IND8         ;  IMP4:IMP3:IMP2:IMP1
	MOVWF FSR          ;    INDTBL
	MOVF TMP4,W
	CALL TABLCON 
          MOVF TMP3,W
          CALL TABLCON
          MOVF TMP2,W
          CALL TABLCON
          MOVF TMP1,W
          CALL TABLCON
          MOVLW IND7
          CALL CLRIND         ;   
          MOVLW 0x0A          ; 0  
	MOVWF IND0          ;  
	MOVLW 0x01          ; 1  
	MOVWF IND9          ;  
	MOVLW 0x0B          ; F  
	MOVWF IND8          ;  
	CALL SHOWIND        ;  
          MOVLW 0x3C          ; TMR1  0,1
	MOVWF TMR1H
	MOVLW 0xB5
	MOVWF TMR1L 
          CLRF IMP1
          CLRF IMP2
	CLRF IMP3
          CLRF IMP4
	CLRF TMR0
	BSF GPIO,INS
          BSF STATUS,RP0      ;1
          BSF TRISIO,INS      ;  
          BCF STATUS,RP0      ;0
	BSF T1CON,TMR1ON
          B ENDINT
          
;***********************************************
;*          1        *
;***********************************************
	          
FR_S      BCF PIR1,TMR1IF
          INCF ZIKL
          MOVLW 0x0A
          SUBWF ZIKL,W
          BZ FR3              ; 10 *0,1=1 ?
          MOVLW 0x3C          ; , 
	MOVWF TMR1H         ;TMR1   0,1
	MOVLW 0xBB
	MOVWF TMR1L
          B ENDINT
FR3       BCF T1CON,TMR1ON
          BSF GPIO,INS
          BSF STATUS,RP0      ;1
          BCF TRISIO,INS      ;  , 1
          BCF STATUS,RP0      ;0
          BTFSS FLAG,CHANGE   ;   ?
          B FR4
          CALL INITPRES       ;  -   TMR0,TMR1
          B FR5
FR4       CALL CLRPRES        ;    TMR0
          MOVF IMP1,W         ;  ,  
          MOVWF IMP1_TMP      ; BINDEC  
          MOVF IMP2,W         ;  IMP4:IMP3:IMP2:IMP1
          MOVWF TMR0          ;    INDTBL
          MOVWF IMP2_TMP
          MOVF IMP3,W
          MOVWF IMP3_TMP
          MOVF IMP4,W
          MOVWF IMP4_TMP
FR5      	CALL BINDEC         ;- 
          MOVLW IND7
	MOVWF FSR
	MOVF TMP4,W
	CALL TABLCON 
          MOVF TMP3,W
          CALL TABLCON
          MOVF TMP2,W
          CALL TABLCON
          MOVF TMP1,W
          CALL TABLCON 
          MOVLW IND7
	CALL CLRIND         ;   
    	MOVLW 0x02          ; 2  
	MOVWF IND9          ;  
	MOVLW 0x0B          ; F  
	MOVWF IND8          ;  
	CALL SHOWIND        ;  
	CLRF ZIKL
          MOVLW 0x3C          ; TMR1  0,1
	MOVWF TMR1H
	MOVLW 0xD0
	MOVWF TMR1L
          CLRF IMP1
          CLRF IMP2
	CLRF IMP3
          CLRF IMP4
	CLRF TMR0
	BSF GPIO,INS        
          BSF STATUS,RP0      ;1
          BSF TRISIO,INS      ;  , 1
          BCF STATUS,RP0      ;0
	BSF T1CON,TMR1ON
          B ENDINT
          
;***********************************************
;*      100 *
;***********************************************

FR_mS_dF  BCF PIR1,TMR1IF
	BSF GPIO,INS
          BSF STATUS,RP0      ;1
          BCF TRISIO,INS      ;  , 0,1
          BCF STATUS,RP0      ;0
          BCF FLAG,CHANGE    
          CALL CLRPRES        ;    TMR0
          CALL DIFFERN        ; dF = IMP4:..:IMP1 = 
          MOVWF IND7          ;IMP4_TMP:..:IMP1_TMP - IMP4:..:IMP1
	CALL BINDEC         ;- 
          MOVLW IND6          ; dF   INDTBL
	MOVWF FSR
          MOVF TMP3,W
          CALL TABLCON
          MOVF TMP2,W
          CALL TABLCON
          MOVF TMP1,W
          CALL TABLCON
          MOVLW IND6
          CALL CLRIND         ;   
          MOVLW 0x0A          ; 0  
	MOVWF IND0          ;  
	MOVLW 0x01          ; 1  
	MOVWF IND9          ;  
	MOVLW 0x0B          ; F  
	MOVWF IND8          ;  
	CALL SHOWIND        ;  
          MOVLW 0x3C          ; TMR1  0,1
	MOVWF TMR1H
	MOVLW 0xB8
	MOVWF TMR1L  
          CLRF IMP1
          CLRF IMP2
	CLRF IMP3
          CLRF IMP4
	CLRF TMR0
	BSF GPIO,INS
          BSF STATUS,RP0      ;1
          BSF TRISIO,INS      ;  , 0,1
          BCF STATUS,RP0      ;0
	BSF T1CON,TMR1ON    
          B ENDINT
          
;***********************************************
;*       1   *
;***********************************************

FR_S_dF   BCF PIR1,TMR1IF
          INCF ZIKL
          MOVLW 0x0A
          SUBWF ZIKL,W
          BZ FR6              ; 10 *0,1=1 ?
          MOVLW 0x3C          ; , 
	MOVWF TMR1H         ;TMR1   0,1
	MOVLW 0xBB
	MOVWF TMR1L
          B ENDINT
FR6       BCF T1CON,TMR1ON
          BSF GPIO,INS
          BSF STATUS,RP0      ;1
          BCF TRISIO,INS      ;  , 0,1
          BCF STATUS,RP0      ;0
          BCF FLAG,CHANGE    
          CALL CLRPRES        ;    TMR0
          CALL DIFFERN        ; dF = IMP4:..:IMP1 = 
          MOVWF TMP6          ;IMP4_TMP:..:IMP1_TMP - IMP4:..:IMP1
	CALL BINDEC         ;- 
          MOVLW IND7          ; dF   INDTBL
	MOVWF FSR
	MOVF TMP4,W
	CALL TABLCON 
          MOVF TMP3,W
          CALL TABLCON
          MOVF TMP2,W
          CALL TABLCON
          MOVF TMP1,W
          CALL TABLCON
          MOVLW IND7
	CALL CLRIND         ;   
	MOVF TMP6,W         ;  
	MOVWF IND7          ;  
    	MOVLW 0x02          ; 2  
	MOVWF IND9          ;  
	MOVLW 0x0B          ; F  
	MOVWF IND8          ;  
	CALL SHOWIND        ;  
	CLRF ZIKL
          MOVLW 0x3C          ; TMR1  0,1
	MOVWF TMR1H
	MOVLW 0xD0
	MOVWF TMR1L
          CLRF IMP1
          CLRF IMP2
	CLRF IMP3
          CLRF IMP4
	CLRF TMR0
	BSF GPIO,INS
          BSF STATUS,RP0      ;1   
          BSF TRISIO,INS      ;  , 0,1
          BCF STATUS,RP0      ;0
	BSF T1CON,TMR1ON
          B ENDINT
          
;***********************************************
;*                              *
;***********************************************  
     
CN_WAIT   BCF PIR1,TMR1IF
          BSF GPIO,INS
          BSF STATUS,RP0       ;1
          BSF TRISIO,INS       ;  
          BCF STATUS,RP0       ;0
          BCF FLAG,CHANGE
          MOVLW 0x0A           ;   
          MOVWF IND0           ;0,8,9 
          MOVWF IND8
          MOVWF IND9
          CLRF IND1
          CLRF IND2
          CLRF IND3
          CLRF IND4
          CLRF IND5
          CLRF IND6
          CLRF IND7
          CALL SHOWIND         ;  
          B ENDINT
          
;***********************************************
;*                               *
;***********************************************  
                          
CN_START  BCF PIR1,TMR1IF
          BTFSS FLAG,CHANGE     ;   ?
          B CN1
          CALL INITPRES         ;  -   TMR0,TMR1
          B CN6
CN1       INCF ZIKL
          MOVLW 0x0A
          SUBWF ZIKL,W
          BZ CN2                ; 10 *0,1=1 ?
          MOVLW 0x3C            ; , 
	MOVWF TMR1H           ;TMR1   0,1
	MOVLW 0xBB
	MOVWF TMR1L
          B ENDINT
CN2       INCF SEC1,W           ;  
          SUBLW 0x0A            ;SEC2:SEC1=SEC2:SEC1+1 
          BNZ CN3
          CLRF SEC1
          INCF SEC2,W
          SUBLW 0x0A
          BNZ CN4
          CLRF SEC2
          B CN5
CN3       INCF SEC1
          B CN5   
CN4       INCF SEC2         
CN5       BCF T1CON,TMR1ON      
	BSF GPIO,INS          
          BSF STATUS,RP0        ;1
          BCF TRISIO,INS        ;  
          BCF STATUS,RP0        ;0
          CALL CLRPRES          ; 
          MOVF IMP1_TMP,W       ;   
	ADDWF IMP1            ;  ,
	BNC CN6               ;  ,
	INCF IMP2             ;     1
	BNZ CN6               ;IMP4_TMP:..:IMP1_TMP=
	INCF IMP3             ;IMP4_TMP:..:IMP1_TMP + IMP4:..:IMP1
	SKPNZ 
	INCF IMP4
CN6	CLRF TMR0
	MOVF IMP1,W          
          MOVWF IMP1_TMP
          MOVF IMP2,W
          MOVWF TMR0
          MOVWF IMP2_TMP
          MOVF IMP3,W
          MOVWF IMP3_TMP
          MOVF IMP4,W
          MOVWF IMP4_TMP
          MOVLW 0x3C            ; TMR1  0,1        
	MOVWF TMR1H
	MOVLW 0xDC
	MOVWF TMR1L
          BSF T1CON,TMR1ON      
          BSF STATUS,RP0        ;1
          BSF TRISIO,INS        ;  
          BCF STATUS,RP0        ;0
CN7      	CALL BINDEC           ;- 
	MOVLW IND7            ;   INDTBL
	MOVWF FSR
	MOVF TMP4,W
          CALL TABLCON
          MOVF TMP3,W
          CALL TABLCON
          MOVF TMP2,W
          CALL TABLCON
          MOVF TMP1,W
          CALL TABLCON
          MOVLW IND7
	MOVWF FSR
	MOVLW 0x07
	MOVWF CNT1
CN8	MOVF INDF,W
	SUBLW 0x0A
	BNZ CN9
	CLRF INDF
	DECF FSR
	DECFSZ CNT1
	B CN8
CN9  	CLRF IND7 
	MOVF SEC1,W
          ANDLW 0x0F
          CALL INDTBL   
	MOVWF IND8
	MOVF SEC2,W
          ANDLW 0x0F
          CALL INDTBL   
	MOVWF IND9
	CALL SHOWIND
	MOVF IMP2_TMP,W
	MOVWF IMP2
	MOVF IMP3_TMP,W
	MOVWF IMP3
	MOVF IMP4_TMP,W
	MOVWF IMP4
	CLRF ZIKL
          B ENDINT   
          
;***********************************************
;*                            *
;***********************************************  
                 
CN_STOP   BCF PIR1,TMR1IF
          BCF T1CON,TMR1ON
          BCF GPIO,INS
          BSF STATUS,RP0        ;1
          BSF TRISIO,INS        ;  
          BCF STATUS,RP0        ;0
          CALL CLRPRES          
ENDINT	SWAPF S_TMP,W
	MOVWF STATUS
	MOVF W_TMP,W
	RETFIE

;***********************************************
;*       TMR0,TMR1       *
;***********************************************   

INITPRES  BCF FLAG,CHANGE 
          MOVLW B'00010001'
          MOVWF T1CON
	BSF INTCON,T0IE
          BSF STATUS,RP0
          MOVLW  B'00110111'
          MOVWF  OPTION_REG
          BSF TRISIO,INS
          BCF STATUS,RP0
	CLRF IMP1
          CLRF IMP2
	CLRF IMP3
          CLRF IMP4
          CLRF SEC1
          CLRF SEC2 
          CLRF IMP1_TMP
	CLRF IMP2_TMP
	CLRF IMP3_TMP
	CLRF IMP4_TMP
          CLRF TMR0
          RETURN
          
;****************************************************
;*      *
;**************************************************** 
        
CLRPRES   MOVF TMR0,W           ;  INS  
	MOVWF IMP2            ;,    
	CLRF IMP1             ; 
CP1	BCF  GPIO,INS          
	NOP
 	NOP
	BSF  GPIO,INS
          INCF IMP1
          MOVF IMP2,W
	SUBWF TMR0,W
	BZ CP1
	COMF IMP1
	INCF IMP1
	RETURN
	
;***********************************************
;*          *
;***********************************************   
	
CLRIND    MOVWF FSR             ;   
          MOVLW 0x07            ;   
	MOVWF CNT1            ; ,
CI1	MOVF INDF,W           ;  
	SUBLW 0x0A            ;   
	SKPZ
	RETURN
	CLRF INDF
	DECF FSR
	DECFSZ CNT1
	B CI1
	RETURN
	
;*************************************************
;* - *
;*************************************************    	

BINDEC    CLRF TMP1            ; 
          CLRF TMP2            ;IMP4:..:IMP1  -
	CLRF TMP3            ; TMP4:..:TMP1
          CLRF TMP4
          MOVLW 0x20
          MOVWF CNT1
BD1       RLF IMP1           
          RLF IMP2
          RLF IMP3
	RLF IMP4
          RLF TMP1
          RLF TMP2
	RLF TMP3
          RLF TMP4
          DECFSZ CNT1
          B BD2
          RETURN
BD2       MOVLW TMP1
          MOVWF FSR
          CALL DEC                                        
          INCF FSR
	CALL DEC
	INCF FSR
	CALL DEC
	INCF FSR
	CALL DEC
          B BD1
DEC       MOVLW 0x03
          ADDWF INDF,W 
          MOVWF TMP5
          BTFSC TMP5,3
          MOVWF INDF
          MOVLW 0x30
          ADDWF INDF,W 
          MOVWF TMP5
          BTFSC TMP5,7
          MOVWF INDF
          RETURN
          
;***********************************************
;*      IND   *
;*********************************************** 
   
TABLCON   MOVWF TMP5           ; -
	SWAPF TMP5,W         ;  TMP5 
          ANDLW 0x0F           ;  INDTBL 
          CALL INDTBL          ;   
          MOVWF INDF           ;  FSR  FSR-1
          DECF FSR
          MOVF TMP5,W
          ANDLW 0x0F
          CALL INDTBL
          MOVWF INDF
          DECF FSR
          RETURN
          
;***********************************************
;*        *
;*********************************************** 
          
DIFFERN   CALL DI1              ; dF = IMP4:..:IMP1 = 
          MOVF IMP1_TMP,W       ;IMP4_TMP:..:IMP1_TMP + (-IMP4:..:IMP1) 
	ADDWF IMP1            ;    W
	SKPNC                 ;   
	CALL DI3              ;W = 0x0F  "-" ,IND7 " - "
	MOVF IMP2_TMP,W       ;W = 0x0D  "+" ,IND7 "|_"
	ADDWF IMP2
	SKPNC
	CALL DI4
	MOVF IMP3_TMP,W
	ADDWF IMP3
	SKPNC
	CALL DI5
	MOVF IMP4_TMP,W
	ADDWF IMP4
	BTFSS IMP4,7
	RETLW 0x0F
DI1	COMF IMP1
          COMF IMP2
          COMF IMP3
          COMF IMP4
          MOVLW 0x01
          ADDWF IMP1
          BNC DI2
          ADDWF IMP2
          BNC DI2       
          ADDWF IMP3
          SKPNC        
          ADDWF IMP4
DI2	RETLW 0x0D		
DI3       MOVLW 0x01
	ADDWF IMP2
	SKPC
	RETURN
DI4       MOVLW 0x01
	ADDWF IMP3
	SKPC
	RETURN	 	
DI5       INCF IMP4
	RETURN
	
;***********************************************
;*        *
;***********************************************  	

SHOWIND   MOVLW 0x0A             ; 10   4
	MOVWF CNT1             ;    IND
          MOVLW IND9             ;   '1'
	MOVWF FSR              ;   
SH1	MOVLW 0x04             ;DIO  70
	MOVWF CNT2             ;   '0'
	SWAPF INDF             ;   
SH2      	RLF INDF               ;DIO  5
	BNC SH3               
          BSF GPIO,DIO
          CALL D70uS
	BCF GPIO,DIO
          B  SH4
SH3       BSF GPIO,DIO
          CALL D5uS
	BCF GPIO,DIO
SH4       CALL D70uS
          DECFSZ CNT2	
	B SH2
	DECF FSR
	CALL D70uS
	DECFSZ CNT1	
	B SH1
	RETURN
	
;***********************************************
;*           1            *
;***********************************************  
		
D1S 	MOVLW 0x05
          MOVWF CNT3
	MOVLW 0xFF
          MOVWF CNT2
          MOVLW 0xFF
          MOVWF CNT1
          DECFSZ CNT1
          B $-1
          DECFSZ CNT2
          B $-5
          DECFSZ CNT3
          B $-9
          RETURN 
           
;***********************************************
;*           10          *
;***********************************************  
          
D10mS     MOVLW 0xFA
          MOVWF CNT4
          MOVLW 0x0C
          MOVWF CNT3
          DECFSZ CNT3
          B $-1
          DECFSZ CNT4
          B $-5
          RETURN 
          
;***********************************************
;*           70         *
;***********************************************   

D70uS     MOVLW 0x15
	MOVWF CNT3
	DECFSZ CNT3
	B $-1
          RETURN
          
;***********************************************
;*           5          *
;*********************************************** 
          
D5uS      RETURN


          END	
